"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isCommand = exports.createCommand = void 0;
const types_1 = require("../types");

/** `rename()` method of `Command`. */
const rename = function (name) {
  this.name = name;
  return this;
};

/** Creates a `Command` instance. */
const createCommand = (params) => ({
  ...params,
  rename,
});
exports.createCommand = createCommand;
const comparison = {
  run: () => Promise.resolve(),
  type: types_1.CommandType.Unit,
  subType: types_1.CommandSubType.Null,
  name: "",
  rename,
};

/** @returns `true` if `obj` is (maybe) a `Command` object. */
//eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
const isCommand = (obj) => {
  if (!obj) return false;
  if (typeof obj !== "object") return false;
  for (const [key, value] of Object.entries(comparison))
    if (typeof obj[key] !== typeof value) return false;
  return true;
};
exports.isCommand = isCommand;
